'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _LayoutState = require('../model/LayoutState');

var _LayoutState2 = _interopRequireDefault(_LayoutState);

var _InnerWrapper = require('./InnerWrapper');

var _InnerWrapper2 = _interopRequireDefault(_InnerWrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OuterWrapper = function OuterWrapper(_ref) {
  var id = _ref.id,
      item = _ref.item,
      Component = _ref.Component,
      RootWrapper = _ref.RootWrapper;

  return _react2.default.createElement(
    RootWrapper,
    _extends({}, item.props, { pseudoRef: function pseudoRef() {}, id: id }),
    _react2.default.createElement(
      Component,
      null,
      item.children.map(function (c) {
        return _react2.default.createElement(Wrapper, { key: c, id: c });
      })
    )
  );
};

OuterWrapper.propTypes = {
  id: _react.PropTypes.string.isRequired,
  item: _react.PropTypes.object.isRequired,
  Component: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.func]).isRequired,
  RootWrapper: _react.PropTypes.func.isRequired
};

var mapStateToProps = function mapStateToProps(_ref2, _ref3) {
  var layoutState = _ref2.layoutState,
      layoutExtras = _ref2.layoutExtras;
  var id = _ref3.id;

  var item = layoutState.getItem(id);
  if (item === undefined) {
    console.log('id', id);
    console.log(layoutState.items.toJS());
  }
  return {
    item: item,
    Component: layoutExtras.components[item.type] || item.type,
    RootWrapper: layoutExtras.RootWrapper
  };
};

var Wrapper = (0, _reactRedux.connect)(mapStateToProps)(OuterWrapper);

exports.default = Wrapper;
module.exports = exports['default'];