'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var PluginProvider = function PluginProvider(_ref) {
  var RootProvider = _ref.RootProvider,
      plugins = _ref.plugins,
      style = _ref.style,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['RootProvider', 'plugins', 'style', 'children']);

  return _react2.default.createElement(
    RootProvider,
    props,
    _react2.default.createElement(
      'div',
      { style: style },
      children,
      plugins.map(function (plugin) {
        return plugin.Component ? _react2.default.createElement(plugin.Component, { key: plugin.Name }) : null;
      })
    )
  );
};

PluginProvider.propTypes = {
  RootProvider: _react.PropTypes.func.isRequired,
  plugins: _react.PropTypes.array.isRequired,
  style: _react.PropTypes.object
};

var mapStateToProps = function mapStateToProps(_ref2) {
  var layoutExtras = _ref2.layoutExtras;
  return {
    RootProvider: layoutExtras.RootProvider,
    plugins: layoutExtras.plugins
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps)(PluginProvider);
module.exports = exports['default'];