'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _redux = require('../redux');

var _redux2 = _interopRequireDefault(_redux);

var _LayoutState = require('../model/LayoutState');

var _LayoutState2 = _interopRequireDefault(_LayoutState);

var _PluginProvider = require('./PluginProvider');

var _PluginProvider2 = _interopRequireDefault(_PluginProvider);

var _actions = require('../actions');

var _InnerWrapper = require('./InnerWrapper');

var _InnerWrapper2 = _interopRequireDefault(_InnerWrapper);

var _shallowCompare = require('../utils/shallowCompare');

var _shallowCompare2 = _interopRequireDefault(_shallowCompare);

var _processPlugins3 = require('../utils/processPlugins');

var _processPlugins4 = _interopRequireDefault(_processPlugins3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LayoutProvider = function (_PureComponent) {
  _inherits(LayoutProvider, _PureComponent);

  function LayoutProvider(props) {
    _classCallCheck(this, LayoutProvider);

    var _this = _possibleConstructorReturn(this, (LayoutProvider.__proto__ || Object.getPrototypeOf(LayoutProvider)).call(this, props));

    var _processPlugins = (0, _processPlugins4.default)(props),
        RootProvider = _processPlugins.RootProvider,
        RootWrapper = _processPlugins.RootWrapper,
        reducers = _processPlugins.reducers,
        middlewares = _processPlugins.middlewares;

    _this.store = (0, _redux2.default)(reducers, {
      layoutState: props.layoutState,
      nextLayoutState: props.layoutState,
      layoutExtras: {
        plugins: props.plugins.map(function (plugin) {
          return plugin(props);
        }),
        components: props.components,
        readOnly: props.readOnly,
        RootProvider: RootProvider,
        RootWrapper: RootWrapper
      }
    }, middlewares);
    return _this;
  }

  _createClass(LayoutProvider, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      var watched = ['components', 'readOnly'];
      if (nextProps.layoutState !== this.props.layoutState) {
        this.store.dispatch((0, _actions.setLayoutState)(nextProps.layoutState));
      }
      if (!(0, _shallowCompare2.default)(nextProps.plugins, this.props.plugins)) {
        console.log('processing plugins');

        var _processPlugins2 = (0, _processPlugins4.default)(nextProps),
            RootWrapper = _processPlugins2.RootWrapper,
            RootProvider = _processPlugins2.RootProvider,
            reducers = _processPlugins2.reducers,
            middlewares = _processPlugins2.middlewares,
            _plugins = _processPlugins2.plugins;

        this.store.dispatch((0, _actions.setExtra)({
          plugins: _plugins,
          RootProvider: RootProvider,
          RootWrapper: RootWrapper
        }));
        this.store.injectReducers(reducers);
        this.store.injectMiddlewares(middlewares);
      }
      watched.forEach(function (key) {
        if (!(0, _shallowCompare2.default)(nextProps[key], _this2.props[key])) _this2.store.dispatch((0, _actions.setExtra)(_defineProperty({}, key, nextProps[key])));
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactRedux.Provider,
        { store: this.store },
        _react2.default.createElement(_PluginProvider2.default, this.props)
      );
    }
  }]);

  return LayoutProvider;
}(_react.PureComponent);

LayoutProvider.propTypes = {
  layoutState: _react.PropTypes.instanceOf(_LayoutState2.default).isRequired,
  onChange: _react.PropTypes.func.isRequired,
  components: _react.PropTypes.object.isRequired,
  plugins: _react.PropTypes.array
};

LayoutProvider.defaultProps = {
  plugins: [],
  onChange: function onChange() {}
};

exports.default = LayoutProvider;
module.exports = exports['default'];