'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = configureStore;

var _redux = require('redux');

var _combineReducers = require('./combineReducers');

var _combineReducers2 = _interopRequireDefault(_combineReducers);

var _layoutState = require('./reducers/layoutState');

var _layoutState2 = _interopRequireDefault(_layoutState);

var _layoutExtras = require('./reducers/layoutExtras');

var _layoutExtras2 = _interopRequireDefault(_layoutExtras);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var composeEnhancers = (typeof window === 'undefined' ? 'undefined' : _typeof(window)) === 'object' && window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ ? window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ : _redux.compose;

function configureStore(reducers, initialState, middlewares) {
  var MasterMiddleware = function MasterMiddleware(store) {
    return function (next) {
      return function (act) {
        var nextMiddleware = function nextMiddleware(remaining) {
          return function (action) {
            return remaining.length ? remaining[0](store)(nextMiddleware(remaining.slice(1)))(action) : next(action);
          };
        };
        nextMiddleware(middlewares)(act);
      };
    };
  };
  var store = (0, _redux.createStore)(createReducer(reducers), initialState, composeEnhancers((0, _redux.applyMiddleware)(MasterMiddleware)));
  store.injectReducers = function (reducers) {
    store.replaceReducer(createReducer(reducers));
  };
  store.injectMiddlewares = function (newMiddlewares) {
    middlewares = newMiddlewares;
  };
  return store;
}

// const injectReducers = (store, reducers) => {
//   store.replaceReducer(createReducer(reducers));
// }

var createReducer = function createReducer(reducers) {
  return (0, _combineReducers2.default)(_extends({}, reducers, {
    layoutState: _layoutState2.default,
    layoutExtras: _layoutExtras2.default
  }));
};

// const createMiddleware = (initialMiddlewares) => {
//   let middlewares = initialMiddlewares;
//   const MasterMiddleware = store => next => act => {
//     const nextMiddleware = remaining => action => remaining.length
//       ? remaining[0](store)(nextMiddleware(remaining.slice(1)))(action)
//       : next(action);
//     nextMiddleware(middlewares)(act);
//   };
//   const injectMiddlewares = (newMiddlewares) => {
//     middlewares = newMiddlewares;
//   }
//   return {
//     MasterMiddleware,
//     injectMiddlewares
//   }
// };

module.exports = exports['default'];