"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var shallowCompare = function shallowCompare(a, b) {
  if (a instanceof Array && b instanceof Array) return shallowCompareArray(a, b);
  if (a instanceof Object && b instanceof Object) return shallowCompareObject(a, b);
  return a === b;
};

var shallowCompareObject = function shallowCompareObject(a, b) {
  var aKeys = Object.keys(a);
  var bKeys = Object.keys(b);
  if (aKeys.length !== bKeys.length) return false;
  for (var i = 0; i < aKeys.length; i++) {
    var key = aKeys[i];
    if (a[key] !== b[key]) return false;
  }
  return true;
};

var shallowCompareArray = function shallowCompareArray(a, b) {
  if (a.length !== b.length) return false;
  for (var i = 0; i < a.length; i++) {
    if (a[i] !== b[i]) return false;
  }
  return true;
};

exports.default = shallowCompare;
module.exports = exports["default"];